VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSocketSecure"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Event Connect()
Public Event Closed()
Public Event SendComplete()
Public Event DataArrival(BinData As String, RemoteHostIP As String)
Public Event LineDataArrival(LineData As String, RemoteHostIP As String)
Public Event Error(Error As Long, Description As String)
Public Event ConnectionRequest()

Public WithEvents mySocket As CSocket
Attribute mySocket.VB_VarHelpID = -1

Private nextEventItem As AEventItem

Private Enum EventNr
    eConnect = 1
    eClosed = 2
    eSendComplete = 3
    eDataArrival = 4
    eLineDataArrival = 5
    eError = 6
    eConnectionRequest = 7
End Enum

Private WithEvents eventTimer As ATimer
Attribute eventTimer.VB_VarHelpID = -1

Public BufferSize As Long

Private Sub Class_Initialize()
    NewInstanz "CSocketSecure"
    BufferSize = 1000
    Set eventTimer = New ATimer
    eventTimer.Delay = 10
    eventTimer.Resolution = 30000
    Set mySocket = New CSocket
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "CSocketSecure"
End Sub

Public Sub Cancel()
    mySocket.Cancel
    Set mySocket = Nothing
    eventTimer.StoppTimer
    Set eventTimer = Nothing
    If Not nextEventItem Is Nothing Then
        nextEventItem.Cancel
        Set nextEventItem = Nothing
    End If
End Sub

Public Property Get EventTimerDelay() As Long
    EventTimerDelay = eventTimer.Delay
End Property

Public Property Let EventTimerDelay(theValue As Long)
    eventTimer.Delay = theValue
End Property

Private Sub eventTimer_Timer()
    eventTimer.StoppTimer
    If nextEventItem Is Nothing Then Exit Sub
    Select Case nextEventItem.EventNr
        Case eConnect
            RaiseEvent Connect
        Case eClosed
            RaiseEvent Closed
        Case eSendComplete
            RaiseEvent SendComplete
        Case eDataArrival
            RaiseEvent DataArrival(nextEventItem.Parameters(1), nextEventItem.Parameters(2))
        Case eLineDataArrival
            RaiseEvent LineDataArrival(nextEventItem.Parameters(1), nextEventItem.Parameters(2))
        Case eError
            RaiseEvent Error(nextEventItem.Parameters(1), nextEventItem.Parameters(2))
        Case eConnectionRequest
            RaiseEvent ConnectionRequest
    End Select
    removeFirstItem
End Sub

Private Sub checkTimer()
    If Not eventTimer.IsRunning Then
        If Not nextEventItem Is Nothing Then
            eventTimer.StartTimer
        End If
    End If
End Sub

Private Sub removeFirstItem()
    Dim NextItem As AEventItem
    Set NextItem = nextEventItem.NextItem
    Set nextEventItem.NextItem = Nothing
    Set nextEventItem = NextItem
    checkTimer
End Sub

Private Sub addItem(theItem As AEventItem)
    If nextEventItem Is Nothing Then
        Set nextEventItem = theItem
        checkTimer
    Else
        If BufferSize > 0 Then
            Dim eventsCount As Long
            eventsCount = getEventsCount()
            If eventsCount > BufferSize Then
                RaiseEvent Error(-1, "buffer overloaded")
                nextEventItem.Cancel
                Set nextEventItem = Nothing
                mySocket.Disconnect
            Else
                Set nextEventItem.GetLastItem().NextItem = theItem
            End If
        Else
            Set nextEventItem.GetLastItem().NextItem = theItem
        End If
    End If
End Sub

Private Function getEventsCount() As Long
    If nextEventItem Is Nothing Then
        getEventsCount = 0
    Else
        getEventsCount = nextEventItem.GetCount()
    End If
End Function

Private Sub mySocket_Closed()
    Dim theItem As New AEventItem
    theItem.EventNr = EventNr.eClosed
    addItem theItem
End Sub

Private Sub mySocket_Connect()
    Dim theItem As New AEventItem
    theItem.EventNr = EventNr.eConnect
    addItem theItem
End Sub

Private Sub mySocket_ConnectionRequest()
    Dim theItem As New AEventItem
    theItem.EventNr = EventNr.eConnectionRequest
    addItem theItem
End Sub

Private Sub mySocket_DataArrival(BinData() As Byte, RemoteHostIP As String)
    Dim theItem As New AEventItem
    theItem.EventNr = EventNr.eDataArrival
    theItem.Parameters.Add StrConv(BinData, vbUnicode)
    theItem.Parameters.Add RemoteHostIP
    addItem theItem
End Sub

Private Sub mySocket_Error(Error As Long, Description As String)
    Dim theItem As New AEventItem
    theItem.EventNr = EventNr.eError
    theItem.Parameters.Add Error
    theItem.Parameters.Add Description
    addItem theItem
End Sub

Private Sub mySocket_LineDataArrival(LineData As String, RemoteHostIP As String)
    Dim theItem As New AEventItem
    theItem.EventNr = EventNr.eLineDataArrival
    theItem.Parameters.Add LineData
    theItem.Parameters.Add RemoteHostIP, 1
    addItem theItem
End Sub

Private Sub mySocket_SendComplete()
    Dim theItem As New AEventItem
    theItem.EventNr = EventNr.eSendComplete
    addItem theItem
End Sub

Public Property Get LocalIP() As String
    LocalIP = mySocket.LocalIP
End Property

Public Property Get SocketHandle&()
    SocketHandle = mySocket.SocketHandle
End Property

Public Property Get State() As sockType
    State = mySocket.State
End Property

Public Property Get LocalPort&()
    LocalPort = mySocket.LocalPort
End Property

Public Property Let LocalPort(theValue&)
    mySocket.LocalPort = theValue
End Property

Public Property Get RemoteHost$()
    RemoteHost = mySocket.RemoteHost
End Property

Public Property Get RemotePort&()
    RemotePort = mySocket.RemotePort
End Property

Public Property Get LineSeparator$()
    LineSeperator = mySocket.LineSeparator
End Property

Public Property Let LineSeperator(theValue$)
    mySocket.LineSeparator = theValue
End Property

Public Property Get TimeOut() As Integer
    TimeOut = mySocket.TimeOut
End Property

Public Property Let TimeOut(theValue As Integer)
    mySocket.TimeOut = theValue
End Property

Public Sub Connect(ByVal Host As String, ByVal Port As Long)
    mySocket.Connect Host, Port
End Sub

Public Sub Listen()
    mySocket.Listen
End Sub

Public Function SendData(Data As Variant) As Long
    SendData = mySocket.SendData(Data)
End Function

Public Sub Disconnect()
    mySocket.Disconnect
End Sub

Public Sub Accept(MyServer As CSocketSecure)
    mySocket.Accept MyServer.mySocket
End Sub

Public Function MyIP() As String
    MyIP = mySocket.MyIP()
End Function

Public Function myName() As String
    myName = mySocket.myName()
End Function

