VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SmtpClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Event SendReady()
Public Event Ready()
Public Event Error(ByVal Number As Long, ByVal Description As String)
Public Event Closed()

Private myMailFrom As String
Private myRcptTo() As String
Private myRcptToIndex As Long
Private myComputername As String
Private myPort As Long
Private myHost As String
Private myMail As AMail

Private WithEvents Socket As CSocket_Client
Attribute Socket.VB_VarHelpID = -1

Private Status As Single

Private AllData As String

Private Sub Class_Initialize()
 NewInstanz "SmtpClient"
 
 Set Socket = New CSocket_Client
End Sub

Private Sub Class_Terminate()
 Set Socket = Nothing
 
 UnloadInstanz "SmtpClient"
End Sub

Private Sub Socket_Closed()
 RaiseEvent Closed
End Sub

Private Sub Socket_Connect()
 Status = 0
End Sub

Public Function SendMail(ByRef theMail As AMail, ByVal MailFrom As String, ByRef RcptTo() As String) As Boolean
 If Status = 0.17 Then
  ReDim myRcptTo(0) As String
  Dim X As Long
  For X = LBound(RcptTo) To UBound(RcptTo)
   If Not RcptTo(X) = "" Then
    ReDim Preserve myRcptTo(UBound(myRcptTo) + 1) As String
    myRcptTo(UBound(myRcptTo)) = RcptTo(X)
   End If
  Next
  If UBound(myRcptTo) = 0 Then
   SendMail = False
   Exit Function
  End If
  myRcptToIndex = 1
  myMailFrom = MailFrom
  Set myMail = theMail
  Status = 0.2
  Socket.SendData "MAIL FROM: <" + MailFrom + ">" + endl
  SendMail = True
 Else
  SendMail = False
 End If
End Function

Public Function QuitConnection() As Boolean
 If Status = 0.17 Then
  Socket.SendData "QUIT" + endl
  Socket.Disconnect
  Status = 0
  QuitConnection = True
 Else
  QuitConnection = False
 End If
End Function

Private Sub Socket_DataArrival(BinData As String, RemoteHostIP As String)
 Dim Temp As String
 Dim X As Long
 Dim Y As Long
 Dim F As Integer
 Dim AktLine As String
 
 Temp = BinData

 AllData = AllData + Temp
CheckNextData:
 F = InStr(AllData, Chr$(10))
 If F = 0 Then Exit Sub
 AktLine = Replace(Left$(AllData, F - 1), Chr$(13), "")
 AllData = Right$(Temp, Len(AllData) - F)
 'Log "SMTP(" + GetServer() + "): " + AktLine
 Select Case Status
  Case 0 'allererste Daten
   If Not AZLeftGleich(UCase$(AktLine) + " ", "220 ") Then
    Socket_Error 0, AktLine
    Exit Sub
   End If
   Socket.SendData "EHLO  " + myComputername + endl
   Status = 0.11
   GoTo CheckNextData
  Case 0.11 'Begrung gesendet
   If AZLeftGleich(UCase$(AktLine), "250-") Then GoTo CheckNextData
   If Not AZLeftGleich(UCase$(AktLine) + " ", "250 ") Then
    Socket_Error 0, AktLine
    Exit Sub
   End If
   Status = 0.17 'Warteschleife
   RaiseEvent Ready
   GoTo CheckNextData
  Case 0.2 'mailfrom gesendet, jetzt rcptto
   If Not AZLeftGleich(UCase$(AktLine) + " ", "250 ") Then
    Socket_Error 0, AktLine
    Exit Sub
   End If
   Socket.SendData "RCPT TO: <" + myRcptTo(myRcptToIndex) + ">" + endl
   myRcptToIndex = myRcptToIndex + 1
   If myRcptToIndex > UBound(myRcptTo) Then Status = 0.3
   GoTo CheckNextData
  Case 0.3 'rcptto gesendet, jetzt eigentliche Mail
   If Not AZLeftGleich(UCase$(AktLine) + " ", "250 ") Then
    Socket_Error 0, AktLine
    Exit Sub
   End If
   Socket.SendData "DATA" + endl
   Status = 1
  Case 1 'eigentliche Mail jetzt senden
   If Not AZLeftGleich(UCase$(AktLine) + " ", "354 ") Then
    Socket_Error 0, AktLine
    Exit Sub
   End If
   Status = 1.1
   For X = 1 To myMail.Headers.Anzahl
    Socket.SendData myMail.Headers.GetHeader(X).theName + ": " _
                  + myMail.Headers.GetHeader(X).theValue + endl
   Next
   Socket.SendData endl + myMail.Data + endl + "." + endl
   Status = 1.2
  Case 1.2 'Mail fertig gesendet
   If Not AZLeftGleich(UCase$(AktLine) + " ", "250 ") Then
    Socket_Error 0, AktLine
    Exit Sub
   End If
   Status = 0.17 'Warteschleife
   RaiseEvent SendReady
 End Select
 Exit Sub
 
Fehler:
 Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
 Resume Next
End Sub

Private Sub Socket_Error(Error As Long, Description As String)
 Socket.Disconnect
 StartProzess "Event SmtpClient_Error"
 On Error GoTo Fehler
 Log_ProzessInfo "Server=" + GetServer()
 Log_ProzessInfo "Nr: " + LTrim$(RTrim$(Str$(Error)))
 Log_ProzessInfo "Description: " + Description
 RaiseEvent Error(Error, Description)
 On Error GoTo 0
 EndProzess "Event SmtpClient_Error"
 Exit Sub
 
Fehler:
 Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
 Resume Next
End Sub

Public Sub Cancel() 'muss vor Terminate ausgefhrt werden!
 If Not Socket Is Nothing Then Socket.Cancel
End Sub

Public Function GetHost() As String
 GetHost = myHost
End Function

Public Function GetPort() As Long
 GetPort = myPort
End Function

Public Function GetServer() As String
 If myPort <> 25 Then
  GetServer = myHost + ":" + LTrim$(RTrim$(Str$(myPort)))
 Else
  GetServer = myHost
 End If
End Function

Public Function GetMail() As AMail
 Set GetMail = myMail
End Function

Public Function GetMailFrom() As String
 GetMailFrom = myMailFrom
End Function

Public Function GetRcptToCount() As Long
 GetRcptToCount = UBound(myRcptTo)
End Function

Public Function GetRcptTo(ByVal Index As Long) As String
 GetRcptTo = myRcptTo(Index)
End Function

Public Sub Connect(ByVal Host As String, Optional ByVal Port As Long = 25, Optional ByVal Computername As String = "ME")
 myComputername = Computername
 myHost = Host
 myPort = Port
 Socket.Connect Host, Port
End Sub
