Attribute VB_Name = "SystemReg_Modul"
Option Explicit

Private Declare Function RegCreateKey Lib "advapi32.dll" _
        Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal _
        lpSubKey As String, phkResult As Long) As Long
        
Private Declare Function RegSetValueEx Lib "advapi32.dll" _
        Alias "RegSetValueExA" (ByVal hKey As Long, ByVal _
        lpValueName As String, ByVal Reserved As Long, _
        ByVal dwType As Long, lpData As Any, ByVal cbData _
        As Long) As Long
  
Private Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, _
        ByVal lpData As String, ByVal cbData As Long) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" _
        (ByVal hKey As Long) As Long

Private Declare Function RegOpenKey Lib "advapi32.dll" _
        Alias "RegOpenKeyA" (ByVal hKey As Long, _
        ByVal lpSubKey As String, phkResult As Long) As Long

Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
        Alias "RegQueryValueExA" (ByVal hKey As Long, _
        ByVal lpValueName As String, ByVal lpReserved As Long, _
        lpType As Long, lpData As Any, lpcbData As Long) As Long

Private Declare Function RegDeleteValue Lib "advapi32.dll" _
        Alias "RegDeleteValueA" (ByVal hKey As Long, _
        ByVal lpValueName As String) As Long

Private Const REG_SZ = 1
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const MAX_PATH = 256
  
Private Const AutoStart_SRPath As String = "Software\Microsoft\Windows\CurrentVersion\Run"

Public Sub CreateAutoStart(ByVal ProgrammName As String, ByVal CommandString As String)
 SystemReg_SaveData HKEY_CURRENT_USER, AutoStart_SRPath, ProgrammName, CommandString
End Sub

Public Function GetAutoStart_CommandString(ByVal ProgrammName As String) As String
 GetAutoStart_CommandString = SystemReg_GetData(HKEY_CURRENT_USER, AutoStart_SRPath, ProgrammName)
End Function

Public Function ExistAutoStart(ByVal ProgrammName As String, ByVal CommandString As String) As Boolean
 ExistAutoStart = (UCase$(GetAutoStart_CommandString(ProgrammName)) = UCase$(CommandString))
End Function

Public Function RemoveAutoStart(ByVal ProgrammName As String)
 SystemReg_DeleteData HKEY_CURRENT_USER, AutoStart_SRPath, ProgrammName
End Function

Public Sub SystemReg_SaveData(hKey As Long, sPath As String, sValue As String, iData As String)
 Dim vRet As Long

 RegCreateKey hKey, sPath, vRet
 RegSetValueEx vRet, sValue, 0, REG_SZ, ByVal iData, Len(iData) + 1
 RegCloseKey vRet
End Sub

Public Function SystemReg_GetData(hKey As Long, sPath As String, sValue As String) As String
 Dim vRet As Long
    
 RegOpenKey hKey, sPath, vRet
 SystemReg_GetData = SystemReg_ReadData(vRet, sValue)
 RegCloseKey vRet
End Function

Private Function SystemReg_ReadData(ByVal hKey As Long, ByVal sValueName As String) As String
 Dim sBuffer As String
 Dim lRes As Long
 Dim lTypeValue As Long
 Dim lBufferSizeData As Long
 Dim iData As Integer

 lRes = RegQueryValueEx(hKey, sValueName, 0, lTypeValue, ByVal 0, lBufferSizeData)
 If lRes = 0 Then
  If lTypeValue = REG_SZ Then
   sBuffer = String(lBufferSizeData, Chr$(0))
   lRes = RegQueryValueEx(hKey, sValueName, 0, 0, ByVal sBuffer, lBufferSizeData)
   If lRes = 0 Then
    SystemReg_ReadData = Left$(sBuffer, InStr(1, sBuffer, Chr$(0)) - 1)
   End If
  End If
 End If
End Function

Public Sub SystemReg_DeleteData(hKey As Long, sPath As String, sValue As String)
 Dim vRet As Long
   
 RegCreateKey hKey, sPath, vRet
 RegDeleteValue vRet, sValue
 RegCloseKey vRet
End Sub

Public Sub TypAssoziieren(ByVal Dateierweiterung As String, ByVal Dateiname As String, ByVal Dateibeschreibung As String, ByVal CommandString As String, Optional ByVal Dateisymbol As String)
 Dim sKeyName As String, sKeyValue As String, lphKey As Long
 Dim RetVal As Long

 ' Schlssel des Typs anlegen; Wert ist die eindeutige Bezeichnung
 If Left$(Dateierweiterung, 1) <> "." Then
  Dateierweiterung = "." + Dateierweiterung
 End If
 sKeyName = Dateierweiterung
 sKeyValue = Dateiname
 RetVal = RegCreateKey(HKEY_CLASSES_ROOT, sKeyName, lphKey&)
 RetVal = RegSetValue(lphKey, "", REG_SZ, sKeyValue, 0&)

 ' Schlssel der TypBezeichnung anlegen; Wert ist der Klartextname des Dateityps
 sKeyName = Dateiname
 sKeyValue = Dateibeschreibung
 RetVal = RegCreateKey(HKEY_CLASSES_ROOT, sKeyName, lphKey&)
 RetVal = RegSetValue(lphKey, "", REG_SZ, sKeyValue, 0&)
    
 ' Unterschlssel anlegen; als Parameter sollte im CommandString "%1" benutzt werden
 sKeyValue = CommandString
 RetVal = RegSetValue(lphKey, "shell\open\command", REG_SZ, sKeyValue, MAX_PATH)
 
 If Not Dateisymbol = "" Then
  sKeyValue = Dateisymbol
  RetVal = RegSetValue(lphKey, "DefaultIcon", REG_SZ, sKeyValue, MAX_PATH)
 End If
End Sub

Public Sub NewProtocol(ByVal ProtocolName As String, ByVal Description As String, ByVal CommandString As String)
 Dim sKeyName As String, sKeyValue As String, lphKey As Long
 Dim RetVal As Long
 
 sKeyName = ProtocolName
 sKeyValue = Description
 RetVal = RegCreateKey(HKEY_CLASSES_ROOT, sKeyName, lphKey&)
 RetVal = RegSetValue(lphKey, "", REG_SZ, sKeyValue, 0&)
 
 SystemReg_SaveData HKEY_CLASSES_ROOT, ProtocolName, "URL Protocol", ""

 sKeyValue = CommandString
 RetVal = RegSetValue(lphKey, "shell\open\command", REG_SZ, sKeyValue, MAX_PATH)
End Sub
