Attribute VB_Name = "windows_Interface"
Option Explicit

Private Declare Function ShellExecute& Lib "shell32.dll" _
  Alias "ShellExecuteA" (ByVal hwnd As Long, _
  ByVal lpOperation As String, ByVal lpFile As String, _
  ByVal lpParameters As String, ByVal lpDirectory As String, _
  ByVal nShowCmd As Long)
        
Private Declare Function SetWindowPos Lib "user32" (ByVal _
             hwnd As Long, ByVal hWndInsertAfter As Long, ByVal _
             X As Long, ByVal Y As Long, ByVal cx As Long, ByVal _
             cy As Long, ByVal wFlags As Long) As Long
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2

Public Declare Function MakePath Lib "imagehlp.dll" Alias _
    "MakeSureDirectoryPathExists" (ByVal lpPath As String) As Long

Public Declare Function SetForegroundWindow Lib "user32" _
      (ByVal hwnd As Long) As Long
Public Declare Function BringWindowToTop Lib "user32" _
      (ByVal hwnd As Long) As Long

Public Sub OpenLocation(TheAddress As String)
    ShellExecute 0, "open", TheAddress, "", "", 1
End Sub

Public Sub OpenBrowser(TheSite As String)  'nur aus Kompatibilitt; besser: OpenLocation
    ShellExecute 0, "open", TheSite, "", "", 1
End Sub

Public Sub OpenMailClient(MailAddress As String)  'nur aus Kompatibilitt; besser: OpenLocation
    ShellExecute 0, "open", "mailto:" + MailAddress, "", "", 1
End Sub

Public Sub Set_FormPos(hwnd As Long, TopMost As Boolean)
    SetWindowPos hwnd, IIf(TopMost, HWND_TOPMOST, HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE
End Sub

Public Function IsLoaded(TheForm As Form) As Boolean
    Dim F As Form
    For Each F In Forms
        If F Is TheForm Then
            IsLoaded = True
            Exit Function
        End If
    Next
    IsLoaded = False
End Function

